import functools


def memoized(func):
    cache = None
    entry = None

    async def callee(*args, **kwargs):
        nonlocal entry, cache, func
        kwargs['modified_entry'] = entry
        returned, entry = await func(*args, **kwargs)
        if returned is not None:
            cache = returned
            return returned
        elif cache is None:
            raise RuntimeError('no ret value')
        else:
            return cache

    # @functools.wraps 대신
    functools.update_wrapper(callee, func)
    return callee
